#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif

static int
_c_constant_10 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     COSE_EDDSA COSE_ES256 COSE_RS256 */
  /* Offset 9 gives the best switch position.  */
  switch (name[9]) {
  case '6':
    if (memEQ(name, "COSE_ES25", 9)) {
    /*                        6     */
#ifdef COSE_ES256
      *iv_return = COSE_ES256;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    if (memEQ(name, "COSE_RS25", 9)) {
    /*                        6     */
#ifdef COSE_RS256
      *iv_return = COSE_RS256;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'A':
    if (memEQ(name, "COSE_EDDS", 9)) {
    /*                        A     */
#ifdef COSE_EDDSA
      *iv_return = COSE_EDDSA;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_c_constant_12 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     COSE_ED25519 COSE_KTY_EC2 COSE_KTY_OKP COSE_KTY_RSA ERR_INTERNAL
     ERR_NOT_BUSY */
  /* Offset 9 gives the best switch position.  */
  switch (name[9]) {
  case '5':
    if (memEQ(name, "COSE_ED25519", 12)) {
    /*                        ^         */
#ifdef COSE_ED25519
      *iv_return = COSE_ED25519;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'E':
    if (memEQ(name, "COSE_KTY_EC2", 12)) {
    /*                        ^         */
#ifdef COSE_KTY_EC2
      *iv_return = COSE_KTY_EC2;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ERR_INTERNAL", 12)) {
    /*                        ^         */
#ifdef ERR_INTERNAL
      *iv_return = ERR_INTERNAL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'O':
    if (memEQ(name, "COSE_KTY_OKP", 12)) {
    /*                        ^         */
#ifdef COSE_KTY_OKP
      *iv_return = COSE_KTY_OKP;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'R':
    if (memEQ(name, "COSE_KTY_RSA", 12)) {
    /*                        ^         */
#ifdef COSE_KTY_RSA
      *iv_return = COSE_KTY_RSA;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'U':
    if (memEQ(name, "ERR_NOT_BUSY", 12)) {
    /*                        ^         */
#ifdef ERR_NOT_BUSY
      *iv_return = ERR_NOT_BUSY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_c_constant_15 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     COSE_ECDH_ES256 ERR_INVALID_SEQ ERR_INVALID_SIG ERR_NOT_ALLOWED
     ERR_PIN_BLOCKED ERR_PIN_INVALID ERR_PIN_NOT_SET ERR_RX_NOT_CBOR
     ERR_UP_REQUIRED EXT_HMAC_SECRET */
  /* Offset 8 gives the best switch position.  */
  switch (name[8]) {
  case 'A':
    if (memEQ(name, "ERR_NOT_ALLOWED", 15)) {
    /*                       ^             */
#ifdef ERR_NOT_ALLOWED
      *iv_return = ERR_NOT_ALLOWED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'B':
    if (memEQ(name, "ERR_PIN_BLOCKED", 15)) {
    /*                       ^             */
#ifdef ERR_PIN_BLOCKED
      *iv_return = ERR_PIN_BLOCKED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'E':
    if (memEQ(name, "ERR_UP_REQUIRED", 15)) {
    /*                       ^             */
#ifdef ERR_UP_REQUIRED
      *iv_return = ERR_UP_REQUIRED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'H':
    if (memEQ(name, "COSE_ECDH_ES256", 15)) {
    /*                       ^             */
#ifdef COSE_ECDH_ES256
      *iv_return = COSE_ECDH_ES256;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'I':
    if (memEQ(name, "ERR_PIN_INVALID", 15)) {
    /*                       ^             */
#ifdef ERR_PIN_INVALID
      *iv_return = ERR_PIN_INVALID;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'L':
    if (memEQ(name, "ERR_INVALID_SEQ", 15)) {
    /*                       ^             */
#ifdef ERR_INVALID_SEQ
      *iv_return = ERR_INVALID_SEQ;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    if (memEQ(name, "ERR_INVALID_SIG", 15)) {
    /*                       ^             */
#ifdef ERR_INVALID_SIG
      *iv_return = ERR_INVALID_SIG;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ERR_PIN_NOT_SET", 15)) {
    /*                       ^             */
#ifdef ERR_PIN_NOT_SET
      *iv_return = ERR_PIN_NOT_SET;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'O':
    if (memEQ(name, "ERR_RX_NOT_CBOR", 15)) {
    /*                       ^             */
#ifdef ERR_RX_NOT_CBOR
      *iv_return = ERR_RX_NOT_CBOR;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case '_':
    if (memEQ(name, "EXT_HMAC_SECRET", 15)) {
    /*                       ^             */
#ifdef EXT_HMAC_SECRET
      *iv_return = EXT_HMAC_SECRET;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_c_constant_16 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ERR_CHANNEL_BUSY ERR_INVALID_CBOR ERR_PIN_REQUIRED EXT_CRED_PROTECT */
  /* Offset 5 gives the best switch position.  */
  switch (name[5]) {
  case 'H':
    if (memEQ(name, "ERR_CHANNEL_BUSY", 16)) {
    /*                    ^                 */
#ifdef ERR_CHANNEL_BUSY
      *iv_return = ERR_CHANNEL_BUSY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'I':
    if (memEQ(name, "ERR_PIN_REQUIRED", 16)) {
    /*                    ^                 */
#ifdef ERR_PIN_REQUIRED
      *iv_return = ERR_PIN_REQUIRED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ERR_INVALID_CBOR", 16)) {
    /*                    ^                 */
#ifdef ERR_INVALID_CBOR
      *iv_return = ERR_INVALID_CBOR;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'R':
    if (memEQ(name, "EXT_CRED_PROTECT", 16)) {
    /*                    ^                 */
#ifdef EXT_CRED_PROTECT
      *iv_return = EXT_CRED_PROTECT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_c_constant_17 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ERR_INVALID_PARAM ERR_LOCK_REQUIRED ERR_NO_OPERATIONS */
  /* Offset 4 gives the best switch position.  */
  switch (name[4]) {
  case 'I':
    if (memEQ(name, "ERR_INVALID_PARAM", 17)) {
    /*                   ^                   */
#ifdef ERR_INVALID_PARAM
      *iv_return = ERR_INVALID_PARAM;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'L':
    if (memEQ(name, "ERR_LOCK_REQUIRED", 17)) {
    /*                   ^                   */
#ifdef ERR_LOCK_REQUIRED
      *iv_return = ERR_LOCK_REQUIRED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ERR_NO_OPERATIONS", 17)) {
    /*                   ^                   */
#ifdef ERR_NO_OPERATIONS
      *iv_return = ERR_NO_OPERATIONS;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_c_constant_18 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ERR_ACTION_TIMEOUT ERR_INVALID_LENGTH ERR_INVALID_OPTION
     ERR_KEY_STORE_FULL ERR_LIMIT_EXCEEDED ERR_NO_CREDENTIALS */
  /* Offset 12 gives the best switch position.  */
  switch (name[12]) {
  case 'C':
    if (memEQ(name, "ERR_LIMIT_EXCEEDED", 18)) {
    /*                           ^            */
#ifdef ERR_LIMIT_EXCEEDED
      *iv_return = ERR_LIMIT_EXCEEDED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'E':
    if (memEQ(name, "ERR_KEY_STORE_FULL", 18)) {
    /*                           ^            */
#ifdef ERR_KEY_STORE_FULL
      *iv_return = ERR_KEY_STORE_FULL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'I':
    if (memEQ(name, "ERR_ACTION_TIMEOUT", 18)) {
    /*                           ^            */
#ifdef ERR_ACTION_TIMEOUT
      *iv_return = ERR_ACTION_TIMEOUT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'L':
    if (memEQ(name, "ERR_INVALID_LENGTH", 18)) {
    /*                           ^            */
#ifdef ERR_INVALID_LENGTH
      *iv_return = ERR_INVALID_LENGTH;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ERR_NO_CREDENTIALS", 18)) {
    /*                           ^            */
#ifdef ERR_NO_CREDENTIALS
      *iv_return = ERR_NO_CREDENTIALS;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'O':
    if (memEQ(name, "ERR_INVALID_OPTION", 18)) {
    /*                           ^            */
#ifdef ERR_INVALID_OPTION
      *iv_return = ERR_INVALID_OPTION;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_c_constant_19 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ERR_INVALID_CHANNEL ERR_INVALID_COMMAND ERR_RX_INVALID_CBOR */
  /* Offset 17 gives the best switch position.  */
  switch (name[17]) {
  case 'E':
    if (memEQ(name, "ERR_INVALID_CHANNEL", 19)) {
    /*                                ^        */
#ifdef ERR_INVALID_CHANNEL
      *iv_return = ERR_INVALID_CHANNEL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ERR_INVALID_COMMAND", 19)) {
    /*                                ^        */
#ifdef ERR_INVALID_COMMAND
      *iv_return = ERR_INVALID_COMMAND;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'O':
    if (memEQ(name, "ERR_RX_INVALID_CBOR", 19)) {
    /*                                ^        */
#ifdef ERR_RX_INVALID_CBOR
      *iv_return = ERR_RX_INVALID_CBOR;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_c_constant_20 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ERR_INVALID_ARGUMENT ERR_KEEPALIVE_CANCEL ERR_OPERATION_DENIED
     ERR_PIN_AUTH_BLOCKED ERR_PIN_AUTH_INVALID */
  /* Offset 17 gives the best switch position.  */
  switch (name[17]) {
  case 'C':
    if (memEQ(name, "ERR_KEEPALIVE_CANCEL", 20)) {
    /*                                ^         */
#ifdef ERR_KEEPALIVE_CANCEL
      *iv_return = ERR_KEEPALIVE_CANCEL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'E':
    if (memEQ(name, "ERR_INVALID_ARGUMENT", 20)) {
    /*                                ^         */
#ifdef ERR_INVALID_ARGUMENT
      *iv_return = ERR_INVALID_ARGUMENT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'I':
    if (memEQ(name, "ERR_OPERATION_DENIED", 20)) {
    /*                                ^         */
#ifdef ERR_OPERATION_DENIED
      *iv_return = ERR_OPERATION_DENIED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'K':
    if (memEQ(name, "ERR_PIN_AUTH_BLOCKED", 20)) {
    /*                                ^         */
#ifdef ERR_PIN_AUTH_BLOCKED
      *iv_return = ERR_PIN_AUTH_BLOCKED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'L':
    if (memEQ(name, "ERR_PIN_AUTH_INVALID", 20)) {
    /*                                ^         */
#ifdef ERR_PIN_AUTH_INVALID
      *iv_return = ERR_PIN_AUTH_INVALID;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_c_constant_21 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     CRED_PROT_UV_OPTIONAL CRED_PROT_UV_REQUIRED ERR_INVALID_PARAMETER
     ERR_MISSING_PARAMETER ERR_OPERATION_PENDING ERR_PIN_TOKEN_EXPIRED
     ERR_REQUEST_TOO_LARGE */
  /* Offset 16 gives the best switch position.  */
  switch (name[16]) {
  case 'I':
    if (memEQ(name, "CRED_PROT_UV_OPTIONAL", 21)) {
    /*                               ^           */
#ifdef CRED_PROT_UV_OPTIONAL
      *iv_return = CRED_PROT_UV_OPTIONAL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'L':
    if (memEQ(name, "ERR_REQUEST_TOO_LARGE", 21)) {
    /*                               ^           */
#ifdef ERR_REQUEST_TOO_LARGE
      *iv_return = ERR_REQUEST_TOO_LARGE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'M':
    if (memEQ(name, "ERR_INVALID_PARAMETER", 21)) {
    /*                               ^           */
#ifdef ERR_INVALID_PARAMETER
      *iv_return = ERR_INVALID_PARAMETER;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    if (memEQ(name, "ERR_MISSING_PARAMETER", 21)) {
    /*                               ^           */
#ifdef ERR_MISSING_PARAMETER
      *iv_return = ERR_MISSING_PARAMETER;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ERR_OPERATION_PENDING", 21)) {
    /*                               ^           */
#ifdef ERR_OPERATION_PENDING
      *iv_return = ERR_OPERATION_PENDING;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'P':
    if (memEQ(name, "ERR_PIN_TOKEN_EXPIRED", 21)) {
    /*                               ^           */
#ifdef ERR_PIN_TOKEN_EXPIRED
      *iv_return = ERR_PIN_TOKEN_EXPIRED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'U':
    if (memEQ(name, "CRED_PROT_UV_REQUIRED", 21)) {
    /*                               ^           */
#ifdef CRED_PROT_UV_REQUIRED
      *iv_return = CRED_PROT_UV_REQUIRED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_c_constant_23 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ERR_CREDENTIAL_EXCLUDED ERR_USER_ACTION_PENDING ERR_USER_ACTION_TIMEOUT */
  /* Offset 18 gives the best switch position.  */
  switch (name[18]) {
  case 'L':
    if (memEQ(name, "ERR_CREDENTIAL_EXCLUDED", 23)) {
    /*                                 ^           */
#ifdef ERR_CREDENTIAL_EXCLUDED
      *iv_return = ERR_CREDENTIAL_EXCLUDED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'M':
    if (memEQ(name, "ERR_USER_ACTION_TIMEOUT", 23)) {
    /*                                 ^           */
#ifdef ERR_USER_ACTION_TIMEOUT
      *iv_return = ERR_USER_ACTION_TIMEOUT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "ERR_USER_ACTION_PENDING", 23)) {
    /*                                 ^           */
#ifdef ERR_USER_ACTION_PENDING
      *iv_return = ERR_USER_ACTION_PENDING;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_c_constant_24 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     ERR_CBOR_UNEXPECTED_TYPE ERR_NO_OPERATION_PENDING ERR_PIN_POLICY_VIOLATION
     */
  /* Offset 22 gives the best switch position.  */
  switch (name[22]) {
  case 'N':
    if (memEQ(name, "ERR_NO_OPERATION_PENDING", 24)) {
    /*                                     ^        */
#ifdef ERR_NO_OPERATION_PENDING
      *iv_return = ERR_NO_OPERATION_PENDING;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'O':
    if (memEQ(name, "ERR_PIN_POLICY_VIOLATION", 24)) {
    /*                                     ^        */
#ifdef ERR_PIN_POLICY_VIOLATION
      *iv_return = ERR_PIN_POLICY_VIOLATION;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'P':
    if (memEQ(name, "ERR_CBOR_UNEXPECTED_TYPE", 24)) {
    /*                                     ^        */
#ifdef ERR_CBOR_UNEXPECTED_TYPE
      *iv_return = ERR_CBOR_UNEXPECTED_TYPE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
_c_constant (pTHX_ const char *name, STRLEN len, IV *iv_return) {
  /* Initially switch on the length of the name.  */
  /* When generated this function returned values for the list of names given
     in this section of perl code.  Rather than manually editing these functions
     to add or remove constants, which would result in this comment and section
     of code becoming inaccurate, we recommend that you edit this section of
     code, and use it to regenerate a new set of constant functions which you
     then use to replace the originals.

     Regenerate these constant functions by feeding this entire source file to
     perl -x

#!/usr/bin/perl5.38.0 -w
use ExtUtils::Constant qw (constant_types C_constant XS_constant);

my $types = {map {($_, 1)} qw(IV)};
my @names = (qw(COSE_ECDH_ES256 COSE_ED25519 COSE_EDDSA COSE_ES256 COSE_KTY_EC2
	       COSE_KTY_OKP COSE_KTY_RSA COSE_P256 COSE_RS256
	       CRED_PROT_UV_OPTIONAL CRED_PROT_UV_OPTIONAL_WITH_ID
	       CRED_PROT_UV_REQUIRED ERR_ACTION_TIMEOUT
	       ERR_CBOR_UNEXPECTED_TYPE ERR_CHANNEL_BUSY
	       ERR_CREDENTIAL_EXCLUDED ERR_ERR_OTHER ERR_INTERNAL
	       ERR_INVALID_ARGUMENT ERR_INVALID_CBOR ERR_INVALID_CHANNEL
	       ERR_INVALID_COMMAND ERR_INVALID_CREDENTIAL ERR_INVALID_LENGTH
	       ERR_INVALID_OPTION ERR_INVALID_PARAM ERR_INVALID_PARAMETER
	       ERR_INVALID_SEQ ERR_INVALID_SIG ERR_KEEPALIVE_CANCEL
	       ERR_KEY_STORE_FULL ERR_LIMIT_EXCEEDED ERR_LOCK_REQUIRED
	       ERR_MISSING_PARAMETER ERR_NOT_ALLOWED ERR_NOT_BUSY
	       ERR_NO_CREDENTIALS ERR_NO_OPERATIONS ERR_NO_OPERATION_PENDING
	       ERR_OPERATION_DENIED ERR_OPERATION_PENDING ERR_PIN_AUTH_BLOCKED
	       ERR_PIN_AUTH_INVALID ERR_PIN_BLOCKED ERR_PIN_INVALID
	       ERR_PIN_NOT_SET ERR_PIN_POLICY_VIOLATION ERR_PIN_REQUIRED
	       ERR_PIN_TOKEN_EXPIRED ERR_PROCESSING ERR_REQUEST_TOO_LARGE
	       ERR_RX ERR_RX_INVALID_CBOR ERR_RX_NOT_CBOR ERR_SPEC_LAST
	       ERR_SUCCESS ERR_TIMEOUT ERR_TX ERR_UNSUPPORTED_ALGORITHM
	       ERR_UNSUPPORTED_EXTENSION ERR_UNSUPPORTED_OPTION ERR_UP_REQUIRED
	       ERR_USER_ACTION_PENDING ERR_USER_ACTION_TIMEOUT
	       ERR_USER_PRESENCE_REQUIRED ERR_UV_BLOCKED EXT_CRED_PROTECT
	       EXT_HMAC_SECRET OK OPT_FALSE OPT_OMIT OPT_TRUE));

print constant_types(), "\n"; # macro defs
foreach (C_constant ("FIDO::Raw", '_c_constant', 'IV', $types, undef, 3, @names) ) {
    print $_, "\n"; # C constant subs
}
print "\n#### XS Section:\n";
print XS_constant ("FIDO::Raw", $types);
__END__
   */

  switch (len) {
  case 2:
    if (name[0] == 'O' && name[1] == 'K') {
#ifdef OK
      *iv_return = OK;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 6:
    /* Names all of length 6.  */
    /* ERR_RX ERR_TX */
    /* Offset 4 gives the best switch position.  */
    switch (name[4]) {
    case 'R':
      if (memEQ(name, "ERR_RX", 6)) {
      /*                   ^       */
#ifdef ERR_RX
        *iv_return = ERR_RX;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'T':
      if (memEQ(name, "ERR_TX", 6)) {
      /*                   ^       */
#ifdef ERR_TX
        *iv_return = ERR_TX;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 8:
    /* Names all of length 8.  */
    /* OPT_OMIT OPT_TRUE */
    /* Offset 4 gives the best switch position.  */
    switch (name[4]) {
    case 'O':
      if (memEQ(name, "OPT_OMIT", 8)) {
      /*                   ^         */
#ifdef OPT_OMIT
        *iv_return = OPT_OMIT;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'T':
      if (memEQ(name, "OPT_TRUE", 8)) {
      /*                   ^         */
#ifdef OPT_TRUE
        *iv_return = OPT_TRUE;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 9:
    /* Names all of length 9.  */
    /* COSE_P256 OPT_FALSE */
    /* Offset 1 gives the best switch position.  */
    switch (name[1]) {
    case 'O':
      if (memEQ(name, "COSE_P256", 9)) {
      /*                ^             */
#ifdef COSE_P256
        *iv_return = COSE_P256;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'P':
      if (memEQ(name, "OPT_FALSE", 9)) {
      /*                ^             */
#ifdef OPT_FALSE
        *iv_return = OPT_FALSE;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 10:
    return _c_constant_10 (aTHX_ name, iv_return);
    break;
  case 11:
    /* Names all of length 11.  */
    /* ERR_SUCCESS ERR_TIMEOUT */
    /* Offset 10 gives the best switch position.  */
    switch (name[10]) {
    case 'S':
      if (memEQ(name, "ERR_SUCCES", 10)) {
      /*                         S      */
#ifdef ERR_SUCCESS
        *iv_return = ERR_SUCCESS;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'T':
      if (memEQ(name, "ERR_TIMEOU", 10)) {
      /*                         T      */
#ifdef ERR_TIMEOUT
        *iv_return = ERR_TIMEOUT;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 12:
    return _c_constant_12 (aTHX_ name, iv_return);
    break;
  case 13:
    /* Names all of length 13.  */
    /* ERR_ERR_OTHER ERR_SPEC_LAST */
    /* Offset 12 gives the best switch position.  */
    switch (name[12]) {
    case 'R':
      if (memEQ(name, "ERR_ERR_OTHE", 12)) {
      /*                           R      */
#ifdef ERR_ERR_OTHER
        *iv_return = ERR_ERR_OTHER;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'T':
      if (memEQ(name, "ERR_SPEC_LAS", 12)) {
      /*                           T      */
#ifdef ERR_SPEC_LAST
        *iv_return = ERR_SPEC_LAST;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 14:
    /* Names all of length 14.  */
    /* ERR_PROCESSING ERR_UV_BLOCKED */
    /* Offset 7 gives the best switch position.  */
    switch (name[7]) {
    case 'B':
      if (memEQ(name, "ERR_UV_BLOCKED", 14)) {
      /*                      ^             */
#ifdef ERR_UV_BLOCKED
        *iv_return = ERR_UV_BLOCKED;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'C':
      if (memEQ(name, "ERR_PROCESSING", 14)) {
      /*                      ^             */
#ifdef ERR_PROCESSING
        *iv_return = ERR_PROCESSING;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 15:
    return _c_constant_15 (aTHX_ name, iv_return);
    break;
  case 16:
    return _c_constant_16 (aTHX_ name, iv_return);
    break;
  case 17:
    return _c_constant_17 (aTHX_ name, iv_return);
    break;
  case 18:
    return _c_constant_18 (aTHX_ name, iv_return);
    break;
  case 19:
    return _c_constant_19 (aTHX_ name, iv_return);
    break;
  case 20:
    return _c_constant_20 (aTHX_ name, iv_return);
    break;
  case 21:
    return _c_constant_21 (aTHX_ name, iv_return);
    break;
  case 22:
    /* Names all of length 22.  */
    /* ERR_INVALID_CREDENTIAL ERR_UNSUPPORTED_OPTION */
    /* Offset 14 gives the best switch position.  */
    switch (name[14]) {
    case 'D':
      if (memEQ(name, "ERR_UNSUPPORTED_OPTION", 22)) {
      /*                             ^              */
#ifdef ERR_UNSUPPORTED_OPTION
        *iv_return = ERR_UNSUPPORTED_OPTION;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'E':
      if (memEQ(name, "ERR_INVALID_CREDENTIAL", 22)) {
      /*                             ^              */
#ifdef ERR_INVALID_CREDENTIAL
        *iv_return = ERR_INVALID_CREDENTIAL;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 23:
    return _c_constant_23 (aTHX_ name, iv_return);
    break;
  case 24:
    return _c_constant_24 (aTHX_ name, iv_return);
    break;
  case 25:
    /* Names all of length 25.  */
    /* ERR_UNSUPPORTED_ALGORITHM ERR_UNSUPPORTED_EXTENSION */
    /* Offset 24 gives the best switch position.  */
    switch (name[24]) {
    case 'M':
      if (memEQ(name, "ERR_UNSUPPORTED_ALGORITH", 24)) {
      /*                                       M      */
#ifdef ERR_UNSUPPORTED_ALGORITHM
        *iv_return = ERR_UNSUPPORTED_ALGORITHM;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'N':
      if (memEQ(name, "ERR_UNSUPPORTED_EXTENSIO", 24)) {
      /*                                       N      */
#ifdef ERR_UNSUPPORTED_EXTENSION
        *iv_return = ERR_UNSUPPORTED_EXTENSION;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 26:
    if (memEQ(name, "ERR_USER_PRESENCE_REQUIRED", 26)) {
#ifdef ERR_USER_PRESENCE_REQUIRED
      *iv_return = ERR_USER_PRESENCE_REQUIRED;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 29:
    if (memEQ(name, "CRED_PROT_UV_OPTIONAL_WITH_ID", 29)) {
#ifdef CRED_PROT_UV_OPTIONAL_WITH_ID
      *iv_return = CRED_PROT_UV_OPTIONAL_WITH_ID;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

